/* TP1 SAS */


/* Question 1: import de la table note*/
proc import datafile='/courses/df5abed5ba27fe300/TP1/notes.csv' out=note_gp1 replace   ; 
guessingrows=100;
delimiter=';'  ;
run ;


 /* Question 2:  importer le fichier note.csv */
data note_gp1_v2;
infile '/courses/df5abed5ba27fe300/TP1/notes.csv' firstobs=2 DLMSTR=";" ; 
/*length Nom $10;*/
input Nom$ sexe$ Note_Math Note_Physique Note_biologie;
run;




/* firstobs indique la ligne  partir de laquelle il faut lire les donnes dans le fichier 
DLM indique le sparateur des colonnes dans le fichier, pour les CSV, c'est ; */ 


/* Question 3: cration de la table SAS malib.note1 */
data note_gp2 ;
input Nom$ sexe$ Note_Math Note_Physique;
cards; 
Anne F 17 12
Antoine M 9 14
Claire F 6 9
David M 12 7
run;

/* Le symbole $ indique qu'il faut lire la variable comme une chane de caractre, par dfaut, 
si l'on indique rien la  variable est lue comme numrique 
Le symbole DDMMYY10. indique qu'il faut lire la variable sous le format date jj/mm/aaaa 
Dans la table SAS, l'affichage de la colonne naissance ne correspond pas  celle voulue :
SAS prsente la variable naissance sous le format date par dfaut (nb de secondes depuis 01/01/1960)
Pour changer a, il faut utiliser l'instruction format qui modifiera le format d'affichage */

 /* Question 4 :concatnation de 2 tables dans la table note : */
data all_notes ;
	set note_gp1  note_gp2 ;
run;

/* Question 5 : cration d'une librairie */
libname malib '/courses/df5abed5ba27fe300';
data malib.all_notes ;
	set all_notes;
run;

/* Question 6: filtrage d'observation avec l'instruction where  */
data femme;
	set all_notes;
	where Sexe="F";
run;

/* Question 7 : idem mais avec l'instruction : if then delete */
data homme;
	set all_notes;
	if Sexe="F" then delete;
run;



/* Question 8 : filtrage d'infos avec where pour les lves ayant au moins 10 dans chaque matire */
data moy;
	set malib.all_notes;
	where note_Math>=10 or note_Physique>=10 or note_biologie>=10;
run;

/* on peut aussi utiliser le symbole |  la place de or : */
data moy2;
	set malib.all_notes;
	where note_Math>=10 | note_Physique>=10 | note_biologie>=10;
run;




/* Question 9: calcul de la moyenne des 3 matires */
data all_notes_wiM;
	set malib.all_notes;
	moyenne=(Note_Math + Note_Physique + Note_biologie)/3;
	moyenne2=mean(Note_Math , Note_Physique , Note_biologie);
	moyenne3=mean(Of Note_:);
run;


/* Question 10 : changer le nom d'une colonne */
data all_notes_wiM2;
	set all_notes_wiM;
	rename Moyenne = moy ;
run;


/* Question 11 : admission */

/* Si on a plusieurs instructions  faire avec un if on utilise l'instruction do */
/* Une boucle do se termine par end */
data malib.all_notes_wiM2;
	set all_notes_wiM2;
	if moy >= 10 then do;
		admission = "Oui" ;
		rattrapage = "Non";
	end;
	else if moy <= 10 & moy >= 8 then do
		admission = "Non" ;
		rattrapage = "Oui";
	end;
	else do;
		admission = "Non";
		rattrapage = "Non";
	end;
run;



/*Question 12 : slection de variable avec keep  */
data admission;
	set malib.all_notes_wiM2;
	keep Nom  Sexe admission rattrapage ;
run;


/* Question 11 : idem mais avec l'instruction drop*/
data admission2;
	set malib.all_notes_wiM2;
	drop Note_Math  Note_biologie Note_Physique moy moyenne2 moyenne3;
run;


/* Question 13 : Affichage presonnes qui vont au rattrapage */
proc print data= admission;
where rattrapage ="Oui";
run;


/* Question 14 */
proc freq data= admission;
table rattrapage*admission / nocol norow nopercent ;
run;


/* Question 15: moyenne de la classe par matire */
proc means data= all_notes_statDesc ; output out=res_mean ;
var Note_Math  Note_biologie Note_Physique;
run;


/* BONUS */
data groupe3  ;
length Nom $20.;
input Nom$	Naissance DDMMYY10.	Sexe$	Note_Math	Note_Physique;
format  naissance DDMMYY10.;
cards;
Anne-Laure 10/05/1995 F 17 12
Armand 24/04/1996 M 8 9
Audrey 18/09/1995 F 16 12
Dave 05/01/1996 M 10 8
Xavier 02/02/1995 M 14 14
run;

data groupe3b;
set groupe3;
annee_naissance = year(naissance);
run;

proc freq data=groupe3b ;
table annee_naissance*sexe / nocol norow  nopercent ;
run;